; Assemblerquelltext des DPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: LCDM.PAS
 
.nolist
.INCLUDE "m644Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        UBRR_VAL  =  0x0020 ; WORD
.equ        CTC_WERT  =  0x0096 ; WORD
.equ        LAENGE_BWS  =  0x074F ; WORD
.equ        ANZAHL_SPALTEN  =  0x004E ; WORD
 
; *** Variablentabelle ***
 
.dseg
 
ZE_ZAEHLER:   ; Byte
.byte     1
SP_ZAEHLER:   ; Byte
.byte     1
AUSGABE:   ; Byte
.byte     1
FUELLBYTE:   ; Byte
.byte     1
BWS_POS:   ; Word
.byte     2
WERT_PIXZEI_CNT:   ; Byte
.byte     1
WERT_ZEILE_CNT:   ; Byte
.byte     1
WERT_ZEIHOEHE_CNT:   ; Byte
.byte     1
WERT_BWS_H:   ; Byte
.byte     1
WERT_BWS_L:   ; Byte
.byte     1
WERT_ZH:   ; Byte
.byte     1
ESC_SEQUENZ_FOLGT:   ; Boolean
.byte     1
WRITE_STRING:   ; String(20)
.byte     1     ; STRING-Laenge
.byte     20
 
BWS:
 .byte     1872
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Timer/Counter1 Compare Match A
.ORG OC1Aaddr
        JMP        TIMER1_COMPA
 
; PROCEDURE - Anfang (TIMER0_AUS)
TIMER0_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; PROCEDURE - Ende (TIMER0_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER0_OVF)
INIT_TIMER0_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIFR0)
        OUT        TIFR0, R16
 
; PROCEDURE - Ende (INIT_TIMER0_OVF)
        RET
 
; PROCEDURE - Anfang (TIMER1_AUS)
TIMER1_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (TIMER1_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER1_COMPA)
INIT_TIMER1_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0A)
        LDI        R16, 0x0A
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT)
        MOV        R16, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R16, R5
 
; Zuweisung Ziel /  VAR (OCR1AH)
        STS        OCR1AH, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (OCR1AL)
        STS        OCR1AL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (INIT_TIMER1_COMPA)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER1_OVF)
INIT_TIMER1_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ASSR)
        STS        ASSR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK2)
        STS        TIMSK2, R16
 
; PROCEDURE - Ende (INIT_TIMER1_OVF)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER2_OVF)
INIT_TIMER2_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR2A)
        STS        TCCR2A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TCCR2B)
        STS        TCCR2B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ASSR)
        STS        ASSR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK2)
        STS        TIMSK2, R16
 
; PROCEDURE - Ende (INIT_TIMER2_OVF)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x8F)
        LDI        R16, 0x8F
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; ISR - Einsprung
TIMER1_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
.equ Fuellzeichen	= ' '


; Im Interrupt genutzte und geaenderte Register:

.def tempi		= r16

.def COPY_L		= r17
.def COPY_H		= r18

.def PixZei_Cnt		= r19		; Pixel-Zeilen-Counter

.def Spalt_Cnt		= r20		; Spalten Counter fuer die Zeichen

.def Zeile_Cnt		= r21		; Zeilen Counter fuer die Zeichen

.def ZeiHoehe_Cnt	= r22		; Counter fuer die Zeichenhoehe



; Register X (R26,R27) enthaelt den Zeiger auf den BWS im RAM fuer die Interruptroutine
; Register Y (R28,R29) enthaelt den Zeiger auf den BWS im RAM fuer den Cursor (aktuelle Position)
; Register Z (R30,R31) enthaelt den Zeiger auf den Font im Flash (mit aktuellem Offset)

; Z: Pointer auf die Schriftart (ZL: ASCII Code, ZH Pixelzeile)



; PortA
;A0 - Frame    - A -> L
;A1 - Load     - A -> L
;A2 - CP       - A -> L
;A3 - Disp_off - A -> L
;A7 - LED_GR   - A -> L

.equ 	FRAME		=0			; FRAME -> FLM, First Line Marker (VSync)
.equ 	LOAD		=1			; CL1, Latch Puls (HSync)
.equ 	COPY		=2			; CL2, Pixelclock
.equ 	DISP_OFF	=3			; Ein/Ausschalten der LCD-Kontrastspannung (Ausgang)
.equ 	LED_GR		=7			; gruene LED


; PortB = D0..D3
; PB5=MOSI, PB6=MISO, PB6=SCK -> waehrend der Programmierung fuer SPI genutzt (im Betrieb frei)



;Werte
.equ Framerate		=50		; Refreshrate
.equ F_CPU		=20000000	; CPU Freq in MHz



; Interne Konstanten
.equ PixelZeilen	=200
.equ HFREQ		=Framerate*PixelZeilen     ; 10000
.equ TDIV		=(F_CPU/16/HFREQ)-1       ; = (1250000/10000)-1 = 125-1 = 124
.equ Zeichenhoehe	=8		; 8, 10, 12
.equ maxSpalten		=78		; maximale physikalische Spaltenzahl minus 2
					; 80-2 -> muss eine gerade Zahl sein
.equ maxSpalten_Half 	=maxSpalten/2
.equ maxZeilen		=(PixelZeilen/Zeichenhoehe)-1	; 200/8-1 -> 24






	;*** Bildbeginn ***


        push    R17  ; COPY_L
        push    R18  ; COPY_H

        push    R19  ; PixZei_Cnt
        lds	PixZei_Cnt, Wert_PixZei_Cnt

        push    R20  ; Spalt_Cnt

        push    R21  ; Zeile_Cnt
        lds	Zeile_Cnt, Wert_Zeile_Cnt

        push    R22  ; ZeiHoehe_Cnt
        lds	ZeiHoehe_Cnt, Wert_ZeiHoehe_Cnt


        push    xl
        push    xh
        lds	xl, Wert_BWS_L
        lds	xh, Wert_BWS_H


        push    zl
        push    zh
        lds	zh, Wert_zh




	; vorbereiten der Register
	in 	tempi, PORTA
	; COPY = 0
	cbr 	tempi, 1<<COPY
	mov 	COPY_L, tempi
	; und COPY = 1
	sbr 	tempi, 1<<COPY
	mov 	COPY_H, tempi




	; Inkrementiern des Pixel-Zeilen-Counters
	inc	PixZei_Cnt


	; ueberspringen der ersten 4 Pixelzeilen
	cpi	PixZei_Cnt, 5		; 1..4 - 5 = Curry
	brcc	hloop_a

	rjmp	hloop_k


hloop_a:

	; ueberspringen der letzten 4 Pixelzeilen
	ldi 	R16, PixelZeilen-4
	cp	R16, PixZei_Cnt		; 196 - (197..200) = Curry
	brcc	hloop_b

	rjmp	hloop_k


hloop_b:

	; Lade Spalt_Cnt mit maxSpalten
	ldi 	Spalt_Cnt, maxSpalten


	; Ein Byte am Zeilenanfang mit Leerzeichen anzeigen
	ldi	R16, 0xFF

	out	PORTA, COPY_L
	nop
	nop
	out	PORTA, COPY_H
	out	PORTB, R16
	out	PORTA, COPY_L
	nop
	nop
	out	PORTA, COPY_H
	out	PORTB, R16



	; Loop fuer 1 Zeile
hloop_c:
	out 	PORTA, COPY_L		; PCLK L		1	-> 4 Takte H
	ld 	ZL, X+	                ; ASCII aus RAM lesen	2
	lpm	R16, Z	                ; Byte aus CGROM lesen	3
	out 	PORTA, COPY_H		; PCLK H		1	-> 4 Takte L
	out	PORTB, R16	        ; Low Nibble ausgeben	1
	out 	PORTA, COPY_L		; PCLK L		1	-> 2 Takte H
	swap 	R16			; 			1
	out 	PORTB, R16		; High Nibble ausgeben	1
	out 	PORTA, COPY_H		; PCLK H		1	-> 3 Takte L
	dec 	Spalt_Cnt	        ;			1
	brne 	hloop_c			;			2
					;		        15 Takte pro Byte


	; Ein Byte am Zeilenende mit Leerzeichen anzeigen
	ldi	R16, 0xFF

	out	PORTA, COPY_L
	nop
	nop
	out	PORTA, COPY_H
	out	PORTB, R16
	out	PORTA, COPY_L
	nop
	nop
	out	PORTA, COPY_H
	out	PORTB, R16



	; COPY_L auf 0
	out 	PORTA, COPY_L			; PCLK L

	; Schalten von LOAD und FRAME
	sbi 	PORTA, LOAD
	dec 	ZeiHoehe_Cnt			; Zaehler fuer Zeichenhoehe erniedrigen
	nop
	nop
	cbi 	PORTA, LOAD
	cbi 	PORTA, FRAME
	breq 	skipcloop			; 1 Textzeile fertig ausgegeben
	inc 	ZH				; Nein -> Bilddatenadresse fuer nachste Pixelzeile laden und

	sbiw 	XL, maxSpalten_Half		; Textadresse wieder an Anfang der Textzeile setzen
	sbiw 	XL, maxSpalten_Half

	rjmp 	hloop_m



	; Alles fuer neue Textzeile einrichten
skipcloop:
	ldi 	ZH, 8				; 1024Bytes CGROM Offset
	ldi 	ZeiHoehe_Cnt, Zeichenhoehe	; Zeichenhoehen Counter laden
	inc 	Zeile_Cnt			; Zeilencounter erhoehen
	cpi 	Zeile_Cnt, maxZeilen	        ; Bildende

        rjmp 	hloop_m



; *** Ausgabe einer Leer-Pixel-Zeile ***
;
hloop_k:
	; Lade Spalt_Cnt mit maxSpalten
	ldi 	Spalt_Cnt, maxSpalten+2


	; Ein Byte am Zeilenanfang mit Leerzeichen anzeigen
	ldi	R16, 0xFF

hloop_l:
	out	PORTA, COPY_L

	nop
	nop
        nop
        nop

	out	PORTA, COPY_H
	out	PORTB, R16
	out	PORTA, COPY_L

	nop
	nop

	out	PORTA, COPY_H
	out	PORTB, R16
	;
	dec	Spalt_Cnt
	brne 	hloop_l

	; COPY_L auf 0
	out 	PORTA, COPY_L		; PCLK L


	; Schalten von LOAD und FRAME
	sbi 	PORTA, LOAD
	nop
	nop
	cbi 	PORTA, LOAD
	cbi 	PORTA, FRAME


	; ist die letzte Bildschirmzeile geschrieben
	cpi	PixZei_Cnt, PixelZeilen
	brne	hloop_m


	; Grundeinstellungen
	clr	PixZei_Cnt
	clr	Zeile_Cnt
	ldi	XL, low(BWS)
	ldi	XH, high(BWS)

	; setzen von FRAME
	sbi 	PORTA, FRAME

hloop_m:

        sts     Wert_zh, zh
        pop     zh  ; font_h
        pop     zl  ; font_l

        sts     Wert_BWS_L, xl
        sts     Wert_BWS_H, xh
        pop     xh  ; Wert_BWS_H
        pop     xl  ; Wert_BWS_L

        sts	Wert_ZeiHoehe_Cnt, ZeiHoehe_Cnt
        pop     R22  ; ZeiHoehe_Cnt

        sts	Wert_Zeile_Cnt, Zeile_Cnt
        pop     R21  ; Zeile_Cnt

        pop     R20  ; Spalt_Cnt

        sts	Wert_PixZei_Cnt, PixZei_Cnt
        pop     R19  ; PixZei_Cnt

        pop     R18  ; COPY_H
        pop     R17  ; COPY_L


 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; PROCEDURE - Anfang (SCHREIBE_ZEICHEN_IN_BWS)
SCHREIBE_ZEICHEN_IN_BWS:
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DAS_BYTE)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (LAENGE_BWS)
        LDI        R18, LOW(0x074F)
        LDI        R19, HIGH(0x074F)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_04
        CLR        R16
        RJMP       M_VERGL_05
M_VERGL_04:
        SER        R16
M_VERGL_05:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01
        RJMP       M_IF_02
M_IF_01:
 
; INC(BWS_POS) - Word
        LDS        R24, BWS_POS
        LDS        R25, BWS_POS+1
        ADIW       R25:R24, 1
        STS        BWS_POS, R24
        STS        BWS_POS+1, R25
 
; IF_THEN - Ende
M_IF_02:
 
; PROCEDURE - Ende (SCHREIBE_ZEICHEN_IN_BWS)
        RET
 
; PROCEDURE - Anfang (SCREEN_ROLL_UP)
SCREEN_ROLL_UP:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R16, LOW(0x004E)
        LDI        R17, HIGH(0x004E)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x074F)
        LDI        R17, HIGH(0x074F)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x004E)
        LDI        R19, HIGH(0x004E)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W3)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (W3)
        MOV        R16, R6
        MOV        R17, R7
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_06:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_07
        RJMP       M_FTD_08
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_07:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (W2)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(W2) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_06
 
; FOR TO DO - Ende
M_FTD_08:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; INC(W3) - Word
        MOV        R24, R6
        MOV        R25, R7
        ADIW       R25:R24, 1
        MOV        R6, R24
        MOV        R7, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W3)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x074F)
        LDI        R17, HIGH(0x074F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_09:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_010
        RJMP       M_FTD_011
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_010:
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FUELLBYTE)
        LDS        R16, FUELLBYTE
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_09
 
; FOR TO DO - Ende
M_FTD_011:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (SCREEN_ROLL_UP)
        RET
 
; PROCEDURE - Anfang (BERECHNE_LF)
BERECHNE_LF:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x074F)
        LDI        R17, HIGH(0x074F)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x004E)
        LDI        R19, HIGH(0x004E)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R18, R2
        MOV        R19, R3
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_015
        CLR        R16
        RJMP       M_VERGL_016
M_VERGL_015:
        SER        R16
M_VERGL_016:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_012
        RJMP       M_IF_013
M_IF_012:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x004E)
        LDI        R19, HIGH(0x004E)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_014
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_013:
 
; Retten der lokalen Parameter fuer PROCEDURE (BERECHNE_LF)
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCREEN_ROLL_UP)
        CALL       SCREEN_ROLL_UP
 
; Retten der Parameter-Register fuer PROCEDURE (BERECHNE_LF)
        POP        R3
        POP        R2
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; IF_THEN_ELSE - Ende
M_IF_014:
 
; PROCEDURE - Ende (BERECHNE_LF)
        RET
 
; PROCEDURE - Anfang (LOESCHE_BWS)
LOESCHE_BWS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_ZAEHLER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x074F)
        LDI        R17, HIGH(0x074F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_017:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_018
        RJMP       M_FTD_019
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_018:
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ZEICHEN_ZAEHLER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FUELLBYTE)
        LDS        R16, FUELLBYTE
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_017
 
; FOR TO DO - Ende
M_FTD_019:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; PROCEDURE - Ende (LOESCHE_BWS)
        RET
 
; PROCEDURE - Anfang (BERECHNE_CR)
BERECHNE_CR:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x004E)
        LDI        R19, HIGH(0x004E)
 
; Operator DIV
        CALL       ASM_UP_MDIV16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x004E)
        LDI        R19, HIGH(0x004E)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; PROCEDURE - Ende (BERECHNE_CR)
        RET
 
; PROCEDURE - Anfang (SCHREIBE_BYTE_IN_BWS)
SCHREIBE_BYTE_IN_BWS:
 
; IF THEN - Ausdruck / Byte-VAR (ESC_SEQUENZ_FOLGT)
        LDS        R16, ESC_SEQUENZ_FOLGT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_020
        RJMP       M_IF_021
M_IF_020:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_022
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_021:
 
; CASE OF - lokaler Uebergabeparameter (DAS_BYTE)
        MOV        R16, R2
 
; CASE OF - vergleiche Einzel-Element ($0A)
        CPI        R16, 0x0A
        BREQ       M_CASE_025
        RJMP       M_CASE_024
M_CASE_025:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R2
 
; Aufruf PROCEDURE (BERECHNE_LF)
        CALL       BERECHNE_LF
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R2
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_023
M_CASE_024:
 
; CASE OF - vergleiche Einzel-Element ($0C)
        CPI        R16, 0x0C
        BREQ       M_CASE_027
        RJMP       M_CASE_026
M_CASE_027:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R2
 
; Aufruf PROCEDURE (LOESCHE_BWS)
        CALL       LOESCHE_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R2
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_023
M_CASE_026:
 
; CASE OF - vergleiche Einzel-Element ($0D)
        CPI        R16, 0x0D
        BREQ       M_CASE_029
        RJMP       M_CASE_028
M_CASE_029:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R2
 
; Aufruf PROCEDURE (BERECHNE_CR)
        CALL       BERECHNE_CR
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R2
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_023
M_CASE_028:
 
; CASE OF - vergleiche Einzel-Element ($1B)
        CPI        R16, 0x1B
        BREQ       M_CASE_031
        RJMP       M_CASE_030
M_CASE_031:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (ESC_SEQUENZ_FOLGT)
        STS        ESC_SEQUENZ_FOLGT, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_023
M_CASE_030:
 
; CASE OF - vergleiche Byte-Element-Bereich <von> ($20)
        CPI        R16, 0x20
        BRCC       M_CASE_034
        RJMP       M_CASE_032
M_CASE_034:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> ($7F)
        LDI        R17, 0x7F
        CP         R17, R16
        BRCC       M_CASE_033
        RJMP       M_CASE_032
M_CASE_033:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R2
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R2
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_023
 
; CASE OF ELSE
M_CASE_032:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        LDI        R16, 0x3C
        MOV        R2, R16
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R2
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R2
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R2
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        LDI        R16, 0x3E
        MOV        R2, R16
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R2
 
; ENDCASE;
M_CASE_023:
 
; IF_THEN_ELSE - Ende
M_IF_022:
 
; PROCEDURE - Ende (SCHREIBE_BYTE_IN_BWS)
        RET
 
; PROCEDURE - Anfang (FUELLE_BWS_MIT_ZEICHEN)
FUELLE_BWS_MIT_ZEICHEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DAS_ZEICHEN)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_ZAEHLER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x074F)
        LDI        R17, HIGH(0x074F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_035:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_036
        RJMP       M_FTD_037
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_036:
 
; Retten der lokalen Parameter fuer PROCEDURE (FUELLE_BWS_MIT_ZEICHEN)
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (DAS_ZEICHEN) retten
        MOV        R18, R4
 
; lokalen Parameter (DAS_ZEICHEN) an Prozedur (SCHREIBE_ZEICHEN_IN_BWS)
        MOV        R2, R18
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (FUELLE_BWS_MIT_ZEICHEN)
        POP        R4
        POP        R3
        POP        R2
 
; INC(DAS_ZEICHEN) - Byte
        INC        R4
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_035
 
; FOR TO DO - Ende
M_FTD_037:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (FUELLE_BWS_MIT_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (WRITE)
WRITE:
 
; Zuweisung Quelle - Ausdruck / Length(WRITE_STRING)
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R4
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_038:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_039
        RJMP       M_FTD_040
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_039:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R4
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R5, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE)
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Parameter (B2) retten
        MOV        R19, R5
 
; lokalen Parameter (B2) an Prozedur (SCHREIBE_BYTE_IN_BWS)
        MOV        R2, R19
 
; Aufruf PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        CALL       SCHREIBE_BYTE_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R4
        INC        R17
        MOV        R4, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_038
 
; FOR TO DO - Ende
M_FTD_040:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE)
        RET
 
; PROCEDURE - Anfang (WRITELN)
WRITELN:
 
; Aufruf PROCEDURE (WRITE)
        CALL       WRITE
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        LDI        R16, 0x0D
        MOV        R2, R16
 
; Aufruf PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        CALL       SCHREIBE_BYTE_IN_BWS
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        LDI        R16, 0x0A
        MOV        R2, R16
 
; Aufruf PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        CALL       SCHREIBE_BYTE_IN_BWS
 
; PROCEDURE - Ende (WRITELN)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; ASM
.equ UBRR0 = UBRR0L

 
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x2E)
        LDI        R16, 0x2E
 
; Zuweisung Ziel /  VAR (FUELLBYTE)
        STS        FUELLBYTE, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Word-Parameter(1) fuer PROCEDURE (INIT_TIMER1_COMPA)
        LDI        R16, LOW(0x0096)
        MOV        R2, R16
        LDI        R17, HIGH(0x0096)
        MOV        R3, R17
 
; Aufruf PROCEDURE (INIT_TIMER1_COMPA)
        CALL       INIT_TIMER1_COMPA
 
; ClearBit(FRAME)
        CBI        PORTA, 0
 
; ClearBit(LOAD)
        CBI        PORTA, 1
 
; ClearBit(CP)
        CBI        PORTA, 2
 
; ClearBit(DISP_OFF)
        CBI        PORTA, 3
 
; ClearBit(LED_GR)
        CBI        PORTA, 7
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_PIXZEI_CNT)
        STS        WERT_PIXZEI_CNT, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_ZEILE_CNT)
        STS        WERT_ZEILE_CNT, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x08)
        LDI        R16, 0x08
 
; Zuweisung Ziel /  VAR (WERT_ZEIHOEHE_CNT)
        STS        WERT_ZEIHOEHE_CNT, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ESC_SEQUENZ_FOLGT)
        STS        ESC_SEQUENZ_FOLGT, R16
 
; Aufruf PROCEDURE (LOESCHE_BWS)
        CALL       LOESCHE_BWS
 
; ASM
   ldi    R16, low(BWS)
   sts    Wert_BWS_L, R16

   ldi    R16, high(BWS)
   sts    Wert_BWS_H, R16

   ldi    R16, 8       		; 1024Bytes CGROM Offset
   sts    Wert_zh, R16

 
 
; Aufruf PROCEDURE (LOESCHE_BWS)
        CALL       LOESCHE_BWS
 
; Interrupt erlauben
        SEI
 
; SetBit(DISP_OFF)
        SBI        PORTA, 3
 
; SetBit(LED_GR)
        SBI        PORTA, 7
 
; LOOP - Start_Marke
M_LOOP_041:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('Hallo Welt ???')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_042
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_042:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_044
M_PRG_CONST_STRING_043:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_043
M_PRG_CONST_STRING_044:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_046
        MOV        R16, R17
M_PRG_CONST_STRING_045:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_045
M_PRG_CONST_STRING_046:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('Dies ist ein')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_047
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_047:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_049
M_PRG_CONST_STRING_048:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_048
M_PRG_CONST_STRING_049:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_051
        MOV        R16, R17
M_PRG_CONST_STRING_050:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_050
M_PRG_CONST_STRING_051:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITE)
        CALL       WRITE
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack (' kleiner Text.')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_052
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_052:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_054
M_PRG_CONST_STRING_053:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_053
M_PRG_CONST_STRING_054:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_056
        MOV        R16, R17
M_PRG_CONST_STRING_055:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_055
M_PRG_CONST_STRING_056:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('Hallo Welt !!!')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_057
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_057:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_059
M_PRG_CONST_STRING_058:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_058
M_PRG_CONST_STRING_059:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_061
        MOV        R16, R17
M_PRG_CONST_STRING_060:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('Dies ist ein')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_062
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_062:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_064
M_PRG_CONST_STRING_063:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_066
        MOV        R16, R17
M_PRG_CONST_STRING_065:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_065
M_PRG_CONST_STRING_066:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITE)
        CALL       WRITE
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WRITE_STRING)=20
        LDI        R16, 20
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack (' kleiner Text.')
        LDI        ZL, LOW(2*M_CONST_STRING_5)
        LDI        ZH, HIGH(2*M_CONST_STRING_5)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_067
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_067:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_069
M_PRG_CONST_STRING_068:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_068
M_PRG_CONST_STRING_069:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WRITE_STRING) - Laenge in R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_071
        MOV        R16, R17
M_PRG_CONST_STRING_070:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_070
M_PRG_CONST_STRING_071:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN)
        CALL       WRITELN
 
; LOOP - Ende
        RJMP       M_LOOP_041
 
; ASM
;*** CG ROM Daten *** (8x8 Zeichensatz)
 
.org 1024
 
font:
 
.db 0xFF,0x18,0x18,0x39,0xFE,0x7C,0xFE,0xFF,0xFF,0xFF,0xFF,0x0F,0x3C,0xFF,0x08,0x66    ; 00FH
.db 0xF7,0xDF,0x7E,0x99,0x08,0x18,0xFF,0x7E,0x7E,0x7E,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 01FH
.db 0xFF,0xFC,0x39,0x39,0xFC,0xFF,0x7C,0xF9,0x7E,0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0x9F    ; 02FH
.db 0x78,0xFC,0x78,0x78,0x3E,0x30,0x7C,0x30,0x78,0x78,0xFF,0xFF,0x7E,0xFF,0xF9,0x78    ; 03FH
.db 0x38,0xFC,0x30,0x3C,0x30,0x10,0x10,0x3C,0x33,0x78,0x1E,0x91,0xF0,0x93,0x93,0x7C    ; 04FH
.db 0x30,0x78,0x30,0x78,0x30,0x33,0x33,0x93,0x93,0x33,0x10,0x78,0xF3,0x78,0xFE,0xFF    ; 05FH
.db 0xFC,0xFF,0xF1,0xFF,0x3E,0xFF,0x7C,0xFF,0xF1,0xFC,0x7E,0xF1,0xF8,0xFF,0xFF,0xFF    ; 06FH
.db 0xFF,0xFF,0xFF,0xFF,0xFE,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x3E,0x7E,0xF1,0x98,0xFE    ; 07FH
.db 0x78,0xFF,0x7E,0x18,0x33,0xF9,0x3C,0xFF,0x18,0x33,0xF9,0x33,0x38,0xF9,0x33,0xFC    ; 08FH
.db 0x7E,0xFF,0x1C,0x78,0xFF,0xF9,0x78,0xF9,0xFF,0x93,0x33,0xFF,0x7C,0x5C,0xFF,0x1F    ; 09FH
.db 0x7E,0x7E,0x3F,0x3F,0x98,0x98,0x3C,0x3C,0xFC,0x3C,0xFF,0x91,0x91,0xFF,0xFF,0xFF    ; 0AFH
.db 0xDD,0xAA,0x22,0x7E,0x7E,0x3F,0x78,0xF3,0x3C,0x9C,0x9C,0xFF,0x9C,0x7E,0x33,0xFF    ; 0BFH
.db 0x7E,0x7E,0xFF,0x7E,0xFF,0x7E,0x98,0x98,0x9C,0xFF,0x9C,0xFF,0x9C,0xFF,0x9C,0xFF    ; 0CFH
.db 0x72,0x30,0x78,0x33,0xF9,0xFF,0x7E,0x78,0x33,0x7E,0xFF,0x00,0xFF,0x7E,0xF9,0x00    ; 0DFH
.db 0x7E,0xFF,0x38,0xFC,0x98,0x98,0xFF,0xFF,0xF0,0x7E,0x78,0xF9,0x7E,0x7E,0xFF,0x7E    ; 0EFH
.db 0xFF,0xFC,0xFF,0x91,0x08,0x18,0xFC,0xFF,0x7C,0xFF,0xFF,0x7C,0x38,0x78,0xFF,0xFF    ; 0FFH
.db 0xFF,0xE7,0x00,0x10,0x7C,0x38,0xFE,0xFF,0xFF,0xFF,0xFF,0x8F,0x99,0xFF,0xC9,0x5A    ; 10FH
.db 0xF1,0x1F,0x3C,0x99,0x42,0xC3,0xFF,0x3C,0x3C,0x7E,0x7E,0xFC,0xFF,0xBD,0x7E,0x00    ; 11FH
.db 0xFF,0x78,0x39,0x39,0x38,0x93,0x39,0xF9,0xFC,0xFC,0x99,0xFC,0xFF,0xFF,0xFF,0x3F    ; 12FH
.db 0x33,0xF0,0x33,0x33,0x3C,0xF3,0xF9,0x33,0x33,0x33,0xFF,0xFF,0xFC,0xFF,0xFC,0x33    ; 13FH
.db 0x93,0x78,0x99,0x99,0x39,0xD9,0xD9,0x99,0x33,0xFC,0x3F,0x99,0xF9,0x11,0x91,0x39    ; 14FH
.db 0x99,0x33,0x99,0x33,0xB4,0x33,0x33,0x93,0x93,0x33,0x33,0xF9,0xF9,0x7E,0x7C,0xFF    ; 15FH
.db 0xFC,0xFF,0xF9,0xFF,0x3F,0xFF,0x39,0xFF,0xF9,0xFF,0xFF,0xF9,0xFC,0xFF,0xFF,0xFF    ; 16FH
.db 0xFF,0xFF,0xFF,0xFF,0xFC,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFC,0x7E,0xFC,0x32,0x7C    ; 17FH
.db 0x33,0x33,0xFC,0xC3,0xFF,0xFC,0x99,0x78,0xC3,0xFF,0xFC,0xFF,0x93,0xFC,0xFC,0x7B    ; 18FH
.db 0xFC,0xFF,0x39,0x33,0x33,0xFC,0x33,0xFC,0x33,0xFF,0xFF,0xFF,0x39,0x39,0xFF,0x4E    ; 19FH
.db 0xFC,0xFC,0x7E,0x7E,0x32,0x32,0x39,0x99,0xFF,0x5A,0xFF,0x39,0x39,0x7E,0xCC,0x33    ; 1AFH
.db 0x77,0x55,0x88,0x7E,0x7E,0x7E,0xB7,0xF9,0xDB,0x9C,0x9C,0xFF,0x9C,0x7E,0x33,0xFF    ; 1BFH
.db 0x7E,0x7E,0xFF,0x7E,0xFF,0x7E,0x32,0x32,0x9C,0xFF,0x9C,0xFF,0x9C,0xFF,0x9C,0xD7    ; 1CFH
.db 0xF8,0x39,0xB7,0xFF,0xFC,0xF3,0xFC,0xB7,0xFF,0x7E,0xFF,0x00,0xFF,0x7E,0xFC,0x00    ; 1DFH
.db 0xFC,0x78,0xD7,0x7E,0x32,0x32,0x99,0xF1,0xF9,0xFC,0xB7,0xFC,0xFC,0xFC,0x30,0xFC    ; 1EFH
.db 0xFF,0xFC,0xFF,0x3D,0x42,0xC3,0xFC,0xFF,0x39,0x33,0xFF,0x78,0x1F,0x3F,0xFF,0xFF    ; 1FFH
.db 0xFF,0xA5,0x42,0x10,0x38,0x7C,0x7C,0xFF,0xFF,0xFF,0xFF,0x0F,0x99,0xFF,0x08,0x3C    ; 20FH
.db 0x70,0x1C,0x18,0x99,0x42,0x78,0xFF,0x18,0x18,0x7E,0x3F,0xF9,0xF3,0x99,0x3C,0x00    ; 21FH
.db 0xFF,0x78,0x39,0x10,0xF3,0x33,0x7C,0xF3,0xF9,0x7E,0x3C,0xFC,0xFF,0xFF,0xFF,0x7E    ; 22FH
.db 0x32,0xFC,0x3F,0x3F,0x39,0x70,0xF3,0x3F,0x33,0x33,0xFC,0xFC,0xF9,0x30,0x7E,0x3F    ; 23FH
.db 0x12,0x33,0x99,0xF3,0x99,0x79,0x79,0xF3,0x33,0xFC,0x3F,0x39,0xF9,0x10,0x90,0x93    ; 24FH
.db 0x99,0x33,0x99,0xF1,0xFC,0x33,0x33,0x93,0x39,0x33,0x76,0xF9,0xFC,0x7E,0x39,0xFF    ; 25FH
.db 0x7E,0x78,0x38,0x78,0x3F,0x78,0xF9,0x98,0x39,0xF8,0x78,0x99,0xFC,0x31,0x70,0x78    ; 26FH
.db 0x32,0x98,0x72,0x38,0x38,0x33,0x33,0x93,0x93,0x33,0x30,0xFC,0x7E,0xFC,0xFF,0x39    ; 27FH
.db 0xF3,0xFF,0x78,0x3C,0x78,0x78,0x3C,0x33,0x3C,0x78,0x78,0xF8,0x7C,0xF8,0x78,0xFC    ; 28FH
.db 0x30,0x08,0x33,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x38,0x33,0x38,0xB9,0x13,0x33,0x7E    ; 29FH
.db 0x78,0xF8,0xFF,0xFF,0xFF,0xFF,0x39,0x99,0xFC,0xA5,0xFF,0x78,0x78,0xFF,0x99,0x99    ; 2AFH
.db 0xDD,0xAA,0x22,0x7E,0x7E,0xFC,0xFC,0xFC,0x64,0x90,0x9C,0x10,0x90,0x18,0x78,0xFF    ; 2BFH
.db 0x7E,0x7E,0xFF,0x7E,0xFF,0x7E,0x78,0xFC,0x8C,0x0C,0x80,0x00,0x8C,0x00,0x80,0x10    ; 2CFH
.db 0x72,0x99,0x30,0x30,0x30,0xFB,0x78,0x78,0x78,0x7E,0xFF,0x00,0xFF,0x7E,0x78,0x00    ; 2DFH
.db 0x38,0x33,0x38,0x38,0xFF,0x38,0x99,0x78,0x38,0x33,0xFF,0x33,0xFF,0x33,0xFF,0xFF    ; 2EFH
.db 0xFF,0x30,0xFF,0x78,0x42,0x78,0xFF,0xFF,0x39,0xFF,0xFF,0x7E,0x3C,0x7C,0x3C,0xFF    ; 2FFH
.db 0xFF,0xE7,0x00,0x10,0x10,0x10,0x38,0xFF,0xFF,0xFF,0xFF,0x28,0x99,0xFF,0xC9,0x81    ; 30FH
.db 0x10,0x10,0x7E,0x99,0x48,0x33,0xFF,0x7E,0x7E,0x7E,0x10,0x10,0xF3,0x00,0x18,0x18    ; 31FH
.db 0xFF,0xFC,0xFF,0x39,0x78,0x7E,0x98,0xFF,0xF9,0x7E,0x00,0x30,0xFF,0x30,0xFF,0xFC    ; 32FH
.db 0x30,0xFC,0x7C,0x7C,0x33,0x3F,0x70,0x7E,0x78,0x38,0xFC,0xFC,0xF3,0xFF,0x3F,0x7E    ; 33FH
.db 0x12,0x33,0x38,0xF3,0x99,0x78,0x78,0xF3,0x30,0xFC,0x3F,0x78,0xF9,0x92,0x12,0x93    ; 34FH
.db 0x38,0x33,0x38,0x7C,0xFC,0x33,0x33,0x92,0x7C,0x78,0xFC,0xF9,0x7E,0x7E,0x93,0xFF    ; 35FH
.db 0xFF,0x3F,0x99,0x33,0x38,0x33,0xF0,0x33,0x98,0xFC,0x7E,0x39,0xFC,0x10,0x33,0x33    ; 36FH
.db 0x99,0x33,0x39,0xF3,0xFC,0x33,0x33,0x93,0x39,0x33,0x76,0xF1,0xFF,0x3E,0xFF,0x93    ; 37FH
.db 0xF3,0x33,0x33,0x9F,0x3F,0x3F,0x9F,0xF3,0x99,0x33,0x33,0xFC,0x7E,0xFC,0x33,0x78    ; 38FH
.db 0xF9,0x3F,0x10,0x78,0x78,0x78,0x33,0x33,0x33,0x93,0x33,0x13,0xF0,0x92,0x78,0x18    ; 39FH
.db 0x3F,0xFC,0x78,0x33,0x70,0x31,0x1C,0x3C,0xF9,0x64,0x30,0x18,0xC8,0x7E,0x33,0xCC    ; 3AFH
.db 0x77,0x55,0x88,0x7E,0x7E,0x78,0x78,0x78,0xE5,0x9F,0x9C,0x9F,0x9F,0xF3,0x30,0xFF    ; 3BFH
.db 0x7E,0x7E,0xFF,0x7E,0xFF,0x7E,0x3F,0x78,0xFC,0xFC,0xFF,0xFF,0xFC,0xFF,0xFF,0x39    ; 3CFH
.db 0x3F,0x90,0xF9,0xF9,0xF9,0xF1,0xFC,0xFC,0xFC,0x7E,0xFF,0x00,0xFF,0xFF,0xFC,0x00    ; 3DFH
.db 0x93,0x70,0x93,0x93,0x78,0x93,0x99,0x39,0x99,0x33,0x33,0x33,0x33,0x33,0xFF,0xFF    ; 3EFH
.db 0xFF,0xFC,0x30,0xCC,0x48,0x33,0x30,0xFF,0x7C,0xFF,0xFF,0x7E,0x1F,0xF9,0x3C,0xFF    ; 3FFH
.db 0xFF,0x24,0xC3,0x38,0x38,0x10,0x10,0xFF,0xFF,0xFF,0xFF,0x33,0x3C,0xFF,0xC9,0x81    ; 40FH
.db 0x70,0x1C,0x7E,0x99,0x4E,0x33,0x18,0x18,0x7E,0x18,0x3F,0xF9,0xF3,0x99,0x00,0x3C    ; 41FH
.db 0xFF,0xFC,0xFF,0x10,0x3F,0xFC,0x32,0xFF,0xF9,0x7E,0x3C,0xFC,0xFF,0xFF,0xFF,0xF9    ; 42FH
.db 0x31,0xFC,0xF9,0x3F,0x10,0x3F,0x33,0xFC,0x33,0x3F,0xFF,0xFF,0xF9,0x30,0x7E,0xFC    ; 43FH
.db 0x12,0x30,0x99,0xF3,0x99,0x79,0x79,0x13,0x33,0xFC,0x33,0x39,0xD9,0x93,0x13,0x93    ; 44FH
.db 0xF9,0x32,0x78,0x3E,0xFC,0x33,0x33,0x10,0x39,0xFC,0xD9,0xF9,0x3F,0x7E,0xFF,0xFF    ; 45FH
.db 0xFF,0x38,0x99,0xF3,0x33,0x30,0xF9,0x33,0x99,0xFC,0x7E,0x78,0xFC,0x92,0x33,0x33    ; 46FH
.db 0x99,0x33,0x39,0x78,0xFC,0x33,0x33,0x92,0x7C,0x33,0xFC,0xFC,0x7E,0xFC,0xFF,0x93    ; 47FH
.db 0x33,0x33,0x30,0x1C,0x38,0x38,0x1C,0x33,0x18,0x30,0x30,0xFC,0x7E,0xFC,0x33,0x33    ; 48FH
.db 0x78,0x08,0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x93,0x33,0x92,0xF9,0x91,0xFC,0x7E    ; 49FH
.db 0x38,0xFC,0x33,0x33,0x33,0x30,0xFF,0xFF,0xF3,0x65,0x3F,0xC9,0x89,0x7E,0x99,0x99    ; 4AFH
.db 0xDD,0xAA,0x22,0x7E,0x70,0x33,0x33,0x33,0x64,0x90,0x9C,0x90,0x10,0xF3,0xFC,0x70    ; 4BFH
.db 0x0E,0x00,0x00,0x0E,0x00,0x00,0x38,0x33,0x0C,0x8C,0x00,0x80,0x8C,0x00,0x80,0x39    ; 4CFH
.db 0x3C,0x99,0x78,0x78,0x78,0xFF,0xFC,0xFC,0xFC,0x70,0x0E,0x00,0x00,0x7E,0xFC,0xFF    ; 4DFH
.db 0x93,0x33,0x93,0x93,0x33,0x93,0x99,0x78,0x38,0x33,0x33,0x33,0x33,0x78,0xFF,0xFF    ; 4EFH
.db 0x30,0xFC,0xFF,0x81,0x4E,0x33,0xFF,0xFF,0xFF,0xFF,0x7E,0x18,0x38,0x38,0x3C,0xFF    ; 4FFH
.db 0xFF,0x66,0x81,0x7C,0x7C,0x92,0x38,0xFF,0xFF,0xFF,0xFF,0x33,0x7E,0xFF,0x89,0x3C    ; 50FH
.db 0xF1,0x1F,0x18,0xFF,0x4E,0x78,0x18,0x3C,0x7E,0x3C,0x7E,0xFC,0x10,0xBD,0x00,0x7E    ; 51FH
.db 0xFF,0xFF,0xFF,0x39,0x70,0x99,0x33,0xFF,0xFC,0xFC,0x99,0xFC,0xF8,0xFF,0xFC,0xF3    ; 52FH
.db 0x33,0xFC,0x33,0x33,0x3F,0x33,0x33,0xF9,0x33,0x7E,0xFC,0xF8,0xFC,0xFF,0xFC,0xFF    ; 53FH
.db 0xF3,0x33,0x99,0x99,0x39,0xD9,0xF9,0x99,0x33,0xFC,0x33,0x99,0x99,0x93,0x93,0x39    ; 54FH
.db 0xF9,0x78,0x39,0x33,0xFC,0x33,0x78,0x11,0x93,0xFC,0x93,0xF9,0x9F,0x7E,0xFF,0xFF    ; 55FH
.db 0xFF,0x33,0x99,0x33,0x33,0xF3,0xF9,0x38,0x99,0xFC,0x7E,0x39,0xFC,0x93,0x33,0x33    ; 56FH
.db 0x38,0x38,0xF9,0x3F,0xBC,0x33,0x78,0x10,0x39,0x38,0xB9,0xFC,0x7E,0xFC,0xFF,0x93    ; 57FH
.db 0x78,0x33,0xF3,0x99,0x33,0x33,0x99,0x78,0xF9,0xF3,0xF3,0xFC,0x7E,0xFC,0x30,0x30    ; 58FH
.db 0xF9,0x33,0x33,0x33,0x33,0x33,0x33,0x33,0x30,0x93,0x33,0x91,0x91,0x39,0x78,0x7E    ; 59FH
.db 0x33,0xFC,0x33,0x33,0x33,0x32,0x18,0x18,0x33,0x99,0x3F,0x13,0x23,0x3C,0xCC,0x33    ; 5AFH
.db 0x77,0x55,0x88,0x7E,0x7E,0x30,0x30,0x30,0xDB,0x9C,0x9C,0x9C,0xFF,0x18,0x30,0x7E    ; 5BFH
.db 0xFF,0xFF,0x7E,0x7E,0xFF,0x7E,0x33,0x30,0xFF,0x9C,0xFF,0x9C,0x9C,0xFF,0x9C,0x10    ; 5CFH
.db 0x39,0x39,0xF9,0xF9,0xF9,0xFF,0xFC,0xFC,0xFC,0xFF,0x7E,0x00,0x00,0x7E,0xFC,0xFF    ; 5DFH
.db 0x93,0x70,0x93,0x93,0x33,0x93,0x38,0xF9,0xF9,0x33,0x33,0x33,0x30,0xFC,0xFF,0xFF    ; 5EFH
.db 0xFF,0xFF,0x30,0x23,0x4E,0x78,0xFC,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x3C,0xFF    ; 5FFH
.db 0xFF,0xE7,0x00,0xFE,0xFE,0xFE,0xFE,0xFF,0xFF,0xFF,0xFF,0x33,0x18,0xFF,0x91,0x5A    ; 60FH
.db 0xF7,0xDF,0x3C,0x99,0x4E,0x37,0x18,0x7E,0x7E,0x7E,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 61FH
.db 0xFF,0xFC,0xFF,0x39,0xFC,0x93,0x98,0xFF,0x7E,0xF9,0xFF,0xFF,0xFC,0xFF,0xFC,0xF7    ; 62FH
.db 0x78,0x30,0x30,0x78,0x3F,0x78,0x78,0xF9,0x78,0xF8,0xFC,0xFC,0x7E,0xFF,0xF9,0xFC    ; 63FH
.db 0x78,0x33,0x30,0x3C,0x30,0x10,0xF0,0x1C,0x33,0x78,0x78,0x91,0x10,0x93,0x93,0x7C    ; 64FH
.db 0xF0,0x3E,0x91,0x78,0x78,0x30,0xFC,0x93,0x93,0x78,0x10,0x78,0xDF,0x78,0xFF,0xFF    ; 65FH
.db 0xFF,0x98,0x34,0x78,0x98,0x78,0xF0,0x3F,0x91,0x78,0x72,0x91,0x78,0x93,0x33,0x78    ; 66FH
.db 0xF9,0x3F,0xF0,0x70,0x7E,0x98,0xFC,0x39,0x93,0x3F,0x30,0x3E,0x7E,0xF1,0xFF,0x10    ; 67FH
.db 0xFC,0x18,0x78,0x0C,0x18,0x18,0x0C,0xFC,0x3C,0x78,0x78,0x78,0x3C,0x78,0x33,0x33    ; 68FH
.db 0x30,0x08,0x13,0x78,0x78,0x78,0x18,0x18,0x3F,0x38,0x78,0x38,0x30,0x74,0x33,0x72    ; 69FH
.db 0x18,0x78,0x78,0x18,0x33,0x33,0xFF,0xFF,0x78,0x3C,0xFF,0x76,0x06,0x3C,0xFF,0xFF    ; 6AFH
.db 0xDD,0xAA,0x22,0x7E,0x7E,0x33,0x33,0x33,0x3C,0x9C,0x9C,0x9C,0xFF,0x7E,0xFC,0x7E    ; 6BFH
.db 0xFF,0xFF,0x7E,0x7E,0xFF,0x7E,0x18,0x33,0xFF,0x9C,0xFF,0x9C,0x9C,0xFF,0x9C,0xD7    ; 6CFH
.db 0x7C,0x30,0x30,0x30,0x30,0xFF,0x78,0x78,0x78,0xFF,0x7E,0x00,0x00,0x7E,0x78,0xFF    ; 6DFH
.db 0x38,0xF3,0x38,0x38,0x78,0x38,0xF9,0xF0,0xF0,0x78,0x78,0x78,0x3F,0x78,0xFF,0xFF    ; 6EFH
.db 0xFF,0x30,0xFF,0x06,0x4E,0x37,0xFC,0xFC,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 6FFH
.db 0xFF,0x18,0x18,0xFF,0xFF,0x7C,0x7C,0xFF,0xFF,0xFF,0xFF,0x78,0x7E,0xFF,0xF3,0x66    ; 70FH
.db 0xFF,0xFF,0x7E,0xFF,0xFF,0x70,0xFF,0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 71FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF9,0xFF,0xFF,0xFF    ; 72FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF9,0xFF,0xFF,0xFF,0xFF    ; 73FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 74FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00    ; 75FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x70,0xFF,0xFF,0xF8,0xFF,0xFF,0xFF,0xFF,0xFF    ; 76FH
.db 0xF0,0x1E,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x70,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 77FH
.db 0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 78FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x70,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8    ; 79FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x0E,0xCF,0x7E,0xFF,0xFF    ; 7AFH
.db 0x77,0x55,0x88,0x7E,0x7E,0xFF,0xFF,0xFF,0xFF,0x9C,0x9C,0x9C,0xFF,0x7E,0xFC,0x7E    ; 7BFH
.db 0xFF,0xFF,0x7E,0x7E,0xFF,0x7E,0xFF,0xFF,0xFF,0x9C,0xFF,0x9C,0x9C,0xFF,0x9C,0xFF    ; 7CFH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x7E,0x00,0x00,0xFF,0xFF,0xFF    ; 7DFH
.db 0xFF,0xF3,0xFF,0xFF,0xFF,0xFF,0xF3,0xFF,0xFF,0xFF,0xFF,0xFF,0x70,0xFF,0xFF,0xFF    ; 7EFH
.db 0xFF,0xFF,0xFF,0xCF,0xFF,0x70,0xFF,0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 7FFH
 
 
 
; *** Unterprogramm Bibliothek ***
; Division von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 24.01.2013
;
; Uebergabe: R16 Divident Low
;            R17 Divident High
;            R18 Divisor Low
;            R18 Divisor High
; Ergebnis:  R16 Quotient Low
;            R17 Quotient High
;            R18 Rest Low 
;            R19 Rest High 
; Temporaere Register: R20,R21,R22


ASM_UP_MDIV16:

        LDI        R20, 16   ; 8 Schritte (R6)

        MOV        R21, R18  ; R21 = Divisor Low
        MOV        R22, R19  ; R22 = Divisor High

        CLR        R18       ; R18 = Rest Low loeschen
        CLR        R19       ; R19 = Rest High loeschen
ASM_UP_MDIV16a:
			      
        LSL        R16       ; Divident Low links Quotient links Bit_0 <- 0   
        ROL        R17       ; Divident High
        ROL        R18       ; Rest Low
        ROL        R19       ; Rest High

        CP         R18, R21  ; Test Rest Low - Divisor Low
        CPC        R19, R22  ; Test Rest High - Divisor High

        BRLO       ASM_UP_MDIV16b   ; Rest < Divisor : Quotient Bit_0 bleibt 0

        SUB        R18, R21  ; Rest Low >= Divisor Low abziehen
        SBC        R19, R22  ; Rest High >= Divisor High abziehen

        INC        R16       ; Quotient Bit_0 wird 1
ASM_UP_MDIV16b:

        DEC        R20       ; Zaehler - 1
        BRNE       ASM_UP_MDIV16a   ; wiederhole 16 mal



        RET






; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High


        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; UBRR0 (V) WORDCONVAR
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; TIMER0_AUS (P) 
; INIT_TIMER0_OVF (P) 
; TIMER1_AUS (P) 
; INIT_TIMER1_COMPA (P) 
; INIT_TIMER1_OVF (P) 
; INIT_TIMER2_OVF (P) 
; UBRR_VAL (C) WORD Wert=0x0020
; CTC_WERT (C) WORD Wert=0x0096
; LAENGE_BWS (C) WORD Wert=0x074F
; ANZAHL_SPALTEN (C) WORD Wert=0x004E
; FRAME (B) BIT
; LOAD (B) BIT
; CP (B) BIT
; DISP_OFF (B) BIT
; LED_GR (B) BIT
; ZE_ZAEHLER (V) BYTE
; SP_ZAEHLER (V) BYTE
; AUSGABE (V) BYTE
; BWS (Y) BYTE
; FUELLBYTE (V) BYTE
; BWS_POS (V) WORD
; WERT_PIXZEI_CNT (V) BYTE
; WERT_ZEILE_CNT (V) BYTE
; WERT_ZEIHOEHE_CNT (V) BYTE
; WERT_BWS_H (V) BYTE
; WERT_BWS_L (V) BYTE
; WERT_ZH (V) BYTE
; ESC_SEQUENZ_FOLGT (V) BOOLEAN
; WRITE_STRING (V) STRING
; INITPORTS (P) 
; SCHREIBE_ZEICHEN_IN_BWS (P) 
; SCREEN_ROLL_UP (P) 
; BERECHNE_LF (P) 
; LOESCHE_BWS (P) 
; BERECHNE_CR (P) 
; SCHREIBE_BYTE_IN_BWS (P) 
; FUELLE_BWS_MIT_ZEICHEN (P) 
; WRITE (P) 
; WRITELN (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE TIMER0_AUS;
; PROCEDURE INIT_TIMER0_OVF;
; PROCEDURE TIMER1_AUS;
; PROCEDURE INIT_TIMER1_COMPA (WERT : WORD) (B_WERT_L : BYTE) (B_WERT_H : BYTE);
; PROCEDURE INIT_TIMER1_OVF;
; PROCEDURE INIT_TIMER2_OVF;
; PROCEDURE INITPORTS;
; PROCEDURE SCHREIBE_ZEICHEN_IN_BWS (DAS_BYTE : BYTE);
; PROCEDURE SCREEN_ROLL_UP (W1 : WORD) (W2 : WORD) (W3 : WORD) (B1 : BYTE);
; PROCEDURE BERECHNE_LF (W1 : WORD);
; PROCEDURE LOESCHE_BWS (ZEICHEN_ZAEHLER : WORD);
; PROCEDURE BERECHNE_CR (W1 : WORD);
; PROCEDURE SCHREIBE_BYTE_IN_BWS (DAS_BYTE : BYTE);
; PROCEDURE FUELLE_BWS_MIT_ZEICHEN (ZEICHEN_ZAEHLER : WORD) (DAS_ZEICHEN : BYTE);
; PROCEDURE WRITE (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN;
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    14, "Hallo Welt ??? "
 
M_CONST_STRING_1:
 .db    12, "Dies ist ein "
 
M_CONST_STRING_2:
 .db    14, " kleiner Text. "
 
M_CONST_STRING_3:
 .db    14, "Hallo Welt !!! "
 
M_CONST_STRING_4:
 .db    12, "Dies ist ein "
 
M_CONST_STRING_5:
 .db    14, " kleiner Text. "
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=INT0          Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=INT1          Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=INT2addr     ISR=INT2          Bemerkung=External Interrupt Request 1
; Nummer=5    ORG=PCI0addr     ISR=PCINT0        Bemerkung=Pin Change Interrupt Request 0
; Nummer=6    ORG=PCI1addr     ISR=PCINT1        Bemerkung=Pin Change Interrupt Request 1
; Nummer=7    ORG=PCI2addr     ISR=PCINT2        Bemerkung=Pin Change Interrupt Request 2
; Nummer=8    ORG=PCI3addr     ISR=PCINT3        Bemerkung=Pin Change Interrupt Request 3
; Nummer=9    ORG=WDTaddr      ISR=WDT           Bemerkung=Watchdog Time-out Interrupt
; Nummer=10   ORG=OC2Aaddr     ISR=TIMER2_COMPA  Bemerkung=Timer/Counter2 Compare Match A
; Nummer=11   ORG=OC2Baddr     ISR=TIMER2_COMPB  Bemerkung=Timer/Counter2 Compare Match B
; Nummer=12   ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=13   ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=14   ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=15   ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=16   ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=17   ORG=OC0Aaddr     ISR=TIMER0_COMPA  Bemerkung=Timer/Counter0 Compare Match A
; Nummer=18   ORG=OC0Baddr     ISR=TIMER0_COMPB  Bemerkung=Timer/Counter0 Compare Match B
; Nummer=19   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=20   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=21   ORG=URXCaddr     ISR=USART0_RXC    Bemerkung=USART0, Rx Complete
; Nummer=22   ORG=UDREaddr     ISR=USART0_UDRE   Bemerkung=USART0 Data Register Empty
; Nummer=23   ORG=UTXCaddr     ISR=USART0_TXC    Bemerkung=USART0, Tx Complete
; Nummer=24   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=25   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=26   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=27   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=28   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
 
